// 3140freqDlg.cpp : implementation file
//

#include "stdafx.h"
#include "3140freq.h"
#include "3140freqDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMy3140freqDlg dialog

CMy3140freqDlg::CMy3140freqDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CMy3140freqDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CMy3140freqDlg)
	m_frequency = _T("");
	m_countHI = _T("");
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CMy3140freqDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CMy3140freqDlg)
	DDX_Control(pDX, IDC_START, m_startButton);
	DDX_Text(pDX, IDC_EDIT2, m_frequency);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CMy3140freqDlg, CDialog)
	//{{AFX_MSG_MAP(CMy3140freqDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_QUIT, OnQuit)
	ON_BN_CLICKED(IDC_START, OnStart)
	ON_WM_TIMER()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMy3140freqDlg message handlers

BOOL CMy3140freqDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here

	UpdateData(FALSE); //Update the display

	m_logicalDevice=0; //Use logical device 0 by default; assigned in DLinx Config Panel
	m_logicalChannel=0; //Use logical channel 0 by default
	m_pSR=(DL_ServiceRequest*)new(DL_ServiceRequest);  //Create the service request
	m_driverInstance=OpenDriverLINX(m_hWnd,"kpci3140"); //Open the dialog box to pick the driver name
	// load "kpci3140" to use the KPCI-3140 card
	// load "kpic3100" to use the KPCI-3101/2/3/4 or KPCI-3110/16
	memset(m_pSR,0,sizeof(DL_ServiceRequest));
	DL_SetServiceRequestSize(*m_pSR);
	m_pSR->device=m_logicalDevice;
	m_pSR->operation=INITIALIZE;
	m_pSR->subsystem=DEVICE;
	m_pSR->mode=OTHER;
	m_pSR->hWnd=m_hWnd;
	DriverLINX(m_pSR); //Execute the initialization service request
	showMessage(m_pSR); //show any errors
	
	// the above code initializes the device and the driver

	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CMy3140freqDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CMy3140freqDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CMy3140freqDlg::showMessage(DL_ServiceRequest *SR)
{
	// if an error occured the Message box operation will display the error message
	SR->operation=MESSAGEBOX;
	DriverLINX(SR);
	return;
}

void CMy3140freqDlg::OnQuit() 
{
	// TODO: Add your control notification handler code here
		KillTimer(IDC_TIMER); //stop the timer
		m_pSR->operation=STOP; //stop the service request
		DriverLINX(m_pSR);
		showMessage(m_pSR);
	delete m_pSR;
	m_pSR=NULL;
	CloseDriverLINX(m_driverInstance);
	m_driverInstance=NULL;
	OnOK();
	
}

void CMy3140freqDlg::OnStart() 
{

// disable the Start Button
	m_startButton.EnableWindow(FALSE);
// add code to stop any active task...only important for other than
// first time through
	m_pSR->operation=STOP;
    DriverLINX(m_pSR);
	

	// code to request a 16bit Freq measurement
	// channel 0 is the first channel in a cascade of channels required to carry
	// out the measurement
	m_pSR->operation=START;   // request a START operation
	m_pSR->subsystem=CT;
	m_pSR->mode=POLLED;       // Polled or single value measurement

	m_pSR->start.typeEvent=COMMAND;  // start on software command

	m_pSR->timing.typeEvent=RATEEVENT;  // timing information will be specified

	m_pSR->stop.typeEvent=TCEVENT;      // stop automatically when the value is acquired

	m_pSR->timing.u.rateEvent.channel=0;   //start wtih logical channel 0 for the cascade of channels
	                                     
	m_pSR->timing.u.rateEvent.mode=FREQ;    // 16bit-freq measure
	
	m_pSR->timing.u.rateEvent.clock=INTERNAL1; //Use internal (crystal) for the timebase
	m_pSR->timing.u.rateEvent.gate=DISABLED;  //no gating will be used..this refers to gateing of the
	           // channels which are generating the GATE signal to the event counting channel
	m_pSR->timing.u.rateEvent.pulses=1;     // generate one cycle for the gate   
	m_pSR->timing.u.rateEvent.period=0;     // single cycle so no period info necessary
	m_pSR->timing.u.rateEvent.onCount=Sec2Tics(0,CT,INTERNAL1,1.0f);  // how long (seconds) should
	// the the GATE be on.......set for 1 second
	DriverLINX(m_pSR);     // execute the Service Request
	showMessage(m_pSR);    // report error if any

	if(m_pSR->result == NoErr) //Start the interval timer if there was no error
		// set timer interval
		SetTimer(IDC_TIMER,(int)(1050),NULL);  // set equal to the GATE time + a little to 
	                                           // allow the operation to complete before reading result
	/*See the OnTimer function to see what happens next*/
}

void CMy3140freqDlg::OnTimer(UINT nIDEvent) 
{
	// TODO: Add your message handler code here and/or call default
	switch(nIDEvent)
	case IDC_TIMER:
	{
		m_pSR->operation=STATUS; //Use the status operation to get the timer count
		m_pSR->status.typeStatus=TIMERSTATUS;
		DriverLINX(m_pSR); //Get the current timer count
		//Display the number of counted pulses
		m_frequency.Format("%d",m_pSR->status.u.timerStatus.count);
  
		UpdateData(FALSE); //Update the display
		showMessage(m_pSR); //show any errors from the STATUS operation

    	KillTimer(IDC_TIMER); //stop the timer
		// enable Start Button for new Reading to be requested
		m_startButton.EnableWindow(TRUE);
		break;
	}

	CDialog::OnTimer(nIDEvent);
}
